/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package ns;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author bar
 */
public class NSDemo {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException, ParserConfigurationException, SAXException, TransformerException {
         if(args.length<1){
             System.out.println("Nutno zadat analyzovany soubor.");
         }
         System.out.print("URI prohledavaneho namespace:");
         String ns = readLine();
         System.out.print("Hledany element:");
         String elementName = readLine();
         Document doc = loadDocument(args[0]);
         NodeList result = doc.getElementsByTagNameNS(ns, elementName);
         System.out.println("\nVysledek:\n");
         displayResult(result,doc);
    }

    private static String readLine() throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        return reader.readLine();
    }

    private static Document loadDocument(String file) throws ParserConfigurationException, SAXException, IOException {
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        dbf.setNamespaceAware(true);
        DocumentBuilder db =  dbf.newDocumentBuilder();
        return db.parse(file);
    }

    private static void displayResult(NodeList result, Document doc) throws TransformerConfigurationException, TransformerException {
        Element root = doc.createElement("results");
        nodeList2Element(root,result,doc);
        TransformerFactory tf = TransformerFactory.newInstance();
        Transformer trans = tf.newTransformer();
        trans.transform(new DOMSource(root), new StreamResult(System.out));
    }

    private static void nodeList2Element(Element root, NodeList result, Document doc) {
        for(int i=0;i<result.getLength();i++){
            Element node = doc.createElement("result");
            node.appendChild(result.item(i));
            root.appendChild(node);
        }
    }
    
}
